// Variadick ablony
#include <array>
#include <iostream>
using namespace std;

template<int ... hodnoty>
auto vra_array()
{
	return array{ hodnoty... };
}

// Tato funkce zastav rekurzi ablon
// Toto lze
//template<class T>
//auto Max(T x)
//{
//	return x;
//}

// ale dnes lze i toto
auto Max(auto x)
{
	return x;
}

template<class T, class ... Typy>
auto Max(T x, Typy ... data)
{
	auto pom = Max(data...);
	return pom > x ? pom : x;
}


int main()
{
	auto x = vra_array<1, 2, 3>();
	cout << Max(1, 2, 9);
}
