// Generovn linernho kdu 
#include <iostream>
using namespace std;

// S pouitm cyklu
double skalrn_souin_1(double* a, double* b, int dlka)
{
	double vsledek = 0;
	for (int i = 0; i < dlka; i++)
		vsledek += a[i] * b[i];
	return vsledek;
}

// Linern kd pro velikost 3
double skalrn_souin_2(double* a, double* b)
{
	return a[0] * b[0] + a[1] * b[1] + a[2] * b[2];
}


// Generovn linernho kdu pro libovoln n
template<int N>
struct skalrn_souin_3
{
	inline static double nsoben(double* a, double* b)
	{
		return *a * *b + skalrn_souin_3<N - 1>::nsoben(a + 1, b + 1);
	}
};

template<>
struct skalrn_souin_3<1>
{
	inline static double nsoben(double* a, double* b)
	{
		return *a * *b;
	}
};

template<int N>
double skalrn_souin(double* a, double* b)
{
	return skalrn_souin_3<N>::nsoben(a, b);
}

int main()
{
	double A[]{ 1,2,3 };
	double B[]{ 1,1,1 };
	cout << skalrn_souin<3>(A, B) << endl;
}